package it.amattioli.dominate.hibernate;

import it.amattioli.dominate.Filter;

import org.apache.commons.collections.Predicate;
import org.hibernate.Query;

/**
 * Allow content filtering for a Hibernate based repository.
 * The filtering is possible in two alternative ways:
 * <ul>
 * 	<li>Using Hql</li>
 * 	<li>Using criteria queries</li>
 * </ul>
 * If you need Hql you have to implement {@link #getHqlQuery()}
 *
 * @author a.mattioli
 *
 */
@Deprecated
public interface HibernateFilter extends Filter {

    /**
     * Retrieves a Hql query string that can be used to filter a class repository
     *
     * @return
     */
    public String getHqlQuery();

    /**
     * Retrieves a Hql query string that can be used to filter a collection repository
     *
     * @return
     */
    public String getHqlFilter();

    /**
     * Set parameters on a Hql query
     * 
     * @param query
     */
    public void setHqlParameters(Query query);

    /**
     * Allow to customize a criteria query.
     * 
     * @param crit
     */
    public void customize(org.hibernate.Criteria crit);
    
    public Predicate getCollectionPredicate();
    
}
