package it.amattioli.dominate.hibernate.filters;

import java.util.Locale;
import java.util.ResourceBundle;

import it.amattioli.dominate.Described;
import it.amattioli.dominate.LocalDescribed;

import org.hibernate.criterion.MatchMode;

public enum ComparisonType implements Described, LocalDescribed {
    
    EXACT(MatchMode.EXACT),
    STARTS(MatchMode.START),
    CONTAINS(MatchMode.ANYWHERE);
    
    private static final String DESCRIPTIONS = "it.amattioli.dominate.hibernate.filters.ComparisonTypeDescriptions";

	ComparisonType(MatchMode matchMode) {
        this.hibernateMode = matchMode;
    }
    
    private final MatchMode hibernateMode;
    
    public MatchMode getMatchMode() {
        return this.hibernateMode;
    }
    
    @Override
	public String getDescription() {
		return ResourceBundle.getBundle(DESCRIPTIONS).getString(this.name());
	}

	@Override
	public String getDescription(Locale locale) {
		return ResourceBundle.getBundle(DESCRIPTIONS, locale).getString(this.name());
	}
}
