package it.amattioli.dominate.specifications;

import java.beans.PropertyChangeListener;
import it.amattioli.common.properties.PropertyChangeSupport;

import it.amattioli.dominate.Entity;
import it.amattioli.dominate.Specification;

public abstract class AbstractSpecification<T extends Entity<?>> implements Specification<T> {
	private PropertyChangeSupport pChange = new PropertyChangeSupport(this);
	private boolean satisfiedIfNotSet = true;

    public void addPropertyChangeListener(final PropertyChangeListener listener) {
        pChange.addPropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(final PropertyChangeListener listener) {
        pChange.removePropertyChangeListener(listener);
    }

    public void firePropertyChange(final String propertyName, final Object oldValue, final Object newValue) {
        pChange.firePropertyChange(propertyName, oldValue, newValue);
    }

	@Override
	public void setSatisfiedIfNotSet(boolean value) {
		this.satisfiedIfNotSet = value;
	}
	
	protected boolean isSatisfiedIfNotSet() {
		return satisfiedIfNotSet;
	}

}
