package it.amattioli.dominate.specifications.hibernate;

import org.hibernate.criterion.Restrictions;

import it.amattioli.dominate.Entity;
import it.amattioli.dominate.specifications.Assembler;
import it.amattioli.dominate.specifications.LongSpecification;

import static it.amattioli.dominate.specifications.TotalOrderComparisonType.*;

public class CriteriaLongSpecification<T extends Entity<?>> extends LongSpecification<T> {

	public CriteriaLongSpecification(String propertyName) {
		super(propertyName);
	}

	public CriteriaLongSpecification(String propertyName, LongSpecification<T> chained) {
		super(propertyName, chained);
	}

	@Override
	public void itselfAssembleQuery(Assembler assembler) {
		addCriteria((CriteriaAssembler) assembler);
	}

	@Override
	public boolean itselfSupportsAssembler(Assembler assembler) {
		return assembler instanceof CriteriaAssembler;
	}
	
	private void addCriteria(CriteriaAssembler assembler) {
        if (wasSet()) {
        	switch (getComparisonType()) {
        	case EQUAL:
        		assembler.addCriterion(Restrictions.eq(getPropertyName(), getValue()));
        		break;
        	case GREATER:
        		assembler.addCriterion(Restrictions.gt(getPropertyName(), getValue()));
        		break;
        	case GREATER_EQ:
        		assembler.addCriterion(Restrictions.ge(getPropertyName(), getValue()));
        		break;
        	case LOWER:
        		assembler.addCriterion(Restrictions.lt(getPropertyName(), getValue()));
        		break;
        	case LOWER_EQ:
        		assembler.addCriterion(Restrictions.le(getPropertyName(), getValue()));
        		break;
        	}
        }
    }

}
